package com.wastedpotential {
	import net.flashpunk.World;
	import net.flashpunk.graphics.Backdrop;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.Entity;
	
	public class GameWorld extends World {
		
		[Embed(source = '../../assets/bg.jpg')] private const BG_TILE:Class;
		
		public function GameWorld() {
			//trace("GameWorld :: CONSTRUCTOR");
			
			//add a background graphic:
			addGraphic(new Image(BG_TILE));
			
			
			/** IMPORTANT!
			 * =======================================================================
			 * this code is not optimized. The method used here to create walls and 
			 * floors from single Entity tiles is a really bad idea. You should always
			 * try to minimize the number of collision tests performed. A better way to
			 * do this would be to create a single large entity for the floor (for 
			 * example)and use a tiled image for the graphic.
			 * =======================================================================
			 */
			
			
			var tileWidth:int = 32;
			//set up top and bottom walls:
			var tileX:int = 0; 
			while (tileX < Settings.STAGE_WIDTH) {
				var wallTileBottom:WallTile = new WallTile(tileX,Settings.STAGE_HEIGHT - tileWidth);
				add(wallTileBottom);
				var wallTileTop:WallTile = new WallTile(tileX, 0);
				add(wallTileTop);
				tileX += wallTileTop.width;
			}
			
			//set up left and right walls:
			var tileY:int = tileWidth;
			while (tileY < Settings.STAGE_HEIGHT - tileWidth) {
				var wallTileLeft:WallTile = new WallTile(0, tileY);
				add(wallTileLeft);
				var wallTileRight:WallTile = new WallTile(Settings.STAGE_WIDTH - tileWidth, tileY);
				add(wallTileRight);
				tileY += wallTileRight.height;
			}
			
			//add platforms:
			for (var i:int = 0; i < 6; i++) {
				var wallTile:WallTile = new WallTile(tileWidth*(i+2), 128);
				add(wallTile);
			}
			for (i = 0; i < 6; i++) {
				var wallTile2:WallTile = new WallTile(tileWidth*(i+9), 256);
				add(wallTile2);
			}
			
			//add a cupcake power up to the stage
			var cupcake1:Item = new Item();
			cupcake1.x = cupcake1.y = 95;
			add(cupcake1);
			
			//add the player:
			var player:Player = new Player();
			player.x = 100;
			player.y = 350;
			add(player);		
		}
		
	} //end class
} //end package