package com.wastedpotential {
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.ui.ContextMenu;
	import flash.ui.ContextMenuItem;
	import flash.events.ContextMenuEvent;
	import net.flashpunk.Engine;
	import net.flashpunk.FP;
	import net.flashpunk.debug.Console;
	
	public class Main extends Engine {
		
		private var testingConsole:TestingGUI = new TestingGUI();
		private static var contextItem:ContextMenuItem;
		
		
		//- flashpunk setup stuff:
		public function Main():void {
			//trace("Main :: CONSTRUCTOR");
			
			//Note: must use variable timestep - for some reason fixed timestep breaks the sprite animations
			super(Settings.STAGE_WIDTH, Settings.STAGE_HEIGHT, Settings.FPS, Settings.FIXED_TIMESTEP); //width, height, framerate, fixed framerate?
			FP.world = new GameWorld;
		}
		
		//on added to stage... add a minimal comps testing console:
		override public function init():void {
			//trace("Main :: init");
			
			FP.stage.addChild(testingConsole); //add the minimal comps testing panel.
			testingConsole.visible = false; //hide the testing panel
			
			//add the testing panel to the flash context menu:
			var contextMenu:ContextMenu = new ContextMenu();
			contextMenu.hideBuiltInItems();
			contextItem = new ContextMenuItem("Show Testing Console", true);
			contextMenu.customItems = [contextItem];
			this.contextMenu = contextMenu;
			contextItem.addEventListener(ContextMenuEvent.MENU_ITEM_SELECT, toggleTestConsole);
			
		}
		
		//- shows or hides the minimal comps testing console:
		private function toggleTestConsole(e:ContextMenuEvent):void{
			//trace("Main :: toggleTestConsole");
			if (testingConsole.visible) {
				testingConsole.visible = false; 
				contextItem.caption = "Show Testing Console";
			}
			else {
				testingConsole.visible = true; 
				contextItem.caption = "Hide Testing Console";
			}
		}		
		
	} //end class
} //end package